import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class FenetrePrincipale extends JFrame{

    private JPanel monPanel;
    // La fenetre de jeu
    PanelJeu pJeu;
    // La fenetre de prevision
    PanelPrevision pPrevi;
    // Le score
    JLabel lScore;
    // Le niveau
    JLabel lNiveau;
    
    public FenetrePrincipale(){
	super();
	super.setTitle("Fenetre Principale");
	super.setSize(450,650);
	super.setResizable(true);
	super.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	// On créera ses trois composantes par appel 
        // a la methode buidContentPane
	pJeu=null;
	pPrevi=null;
	lScore=null;
	
    }

    public PanelJeu getPJeu(){
	return pJeu;
    }

    
    public void maj(){
	// Pour repeindre les differentes fenetres
	// La methode repaint() fait appel aux méthodes paintComponent
	// de chacun de ces objets
	pJeu.repaint();
	pPrevi.repaint();
	lScore.repaint();
    }
   
    
    public void construit(){
	setContentPane(buildContentPanel());
	setVisible(true);
	
	//Pour dire ce qui se passe lorsque l'on appuie sur 
	// les flèches hout, bas, droite, gauche
	addKeyListener(new KeyListener()
	    {
		public void keyPressed(KeyEvent e){
		    if(e.getKeyCode()==KeyEvent.VK_UP){
			pJeu.hautRectangle();
			lScore.setText("1");
			maj();
			
		    }
		    if(e.getKeyCode()==KeyEvent.VK_DOWN){
			pJeu.basRectangle();
			lScore.setText("2");
			maj();
		    }
		    if(e.getKeyCode()==KeyEvent.VK_LEFT){
			pJeu.gaucheRectangle();
			lScore.setText("3");
			maj();
		    }
		    if(e.getKeyCode()==KeyEvent.VK_RIGHT){
			pJeu.droiteRectangle();
			lScore.setText("4");
			maj();
		    }
		    
		}
		
		public void keyReleased(KeyEvent e){
		    
		}

		public void keyTyped(KeyEvent e){
		    
		}
	    }
	    );
    }
	   

    public JPanel buildContentPanel(){
	monPanel=new JPanel();
	SpringLayout layout=new SpringLayout();
	monPanel.setLayout(layout);
	// On paint le fond en vert
	monPanel.setBackground(Color.green);

	// On cree la fenetre de Jeu et on la positionne
	pJeu=new PanelJeu();
	monPanel.add(pJeu);
	layout.putConstraint(SpringLayout.WEST, pJeu,
                     10,
			     SpringLayout.WEST,monPanel);
	layout.putConstraint(SpringLayout.NORTH, pJeu,
                     20,
                     SpringLayout.NORTH, monPanel);

	// On cree la fenetre de prevision et on la positionne
	pPrevi=new PanelPrevision();
	monPanel.add(pPrevi);
	layout.putConstraint(SpringLayout.WEST, pPrevi,
                     10,
			     SpringLayout.EAST,pJeu);
	layout.putConstraint(SpringLayout.NORTH, pPrevi,
                     20,
                     SpringLayout.NORTH, monPanel);
	


	// On cree le texte Score et on le positionne
	JLabel labelTextScore=new JLabel("Score");
	Font f= new Font("Courier", Font.PLAIN, 30);
	labelTextScore.setFont(f);
	monPanel.add(labelTextScore);
	layout.putConstraint(SpringLayout.WEST, labelTextScore,
                     10,
			     SpringLayout.EAST,pJeu);
	layout.putConstraint(SpringLayout.NORTH, labelTextScore,
                     20,
                     SpringLayout.SOUTH, pPrevi);
	
	// On cree le score et le positionne
	lScore=new JLabel("0");
	Font fscore= new Font("Courier", Font.PLAIN, 30);
	lScore.setFont(fscore);
	monPanel.add(lScore);
	layout.putConstraint(SpringLayout.WEST, lScore,
                     20,
			     SpringLayout.EAST,pJeu);
	layout.putConstraint(SpringLayout.NORTH, lScore,
                     10,
                     SpringLayout.SOUTH, labelTextScore);

	// On cree le texte Niveau et on le positionne
	JLabel labelTextNiveau=new JLabel("Niveau");
	Font ftextniveau= new Font("Courier", Font.PLAIN, 30);
	labelTextNiveau.setFont(ftextniveau);
	monPanel.add(labelTextNiveau);
	layout.putConstraint(SpringLayout.WEST, labelTextNiveau,
                     10,
			     SpringLayout.EAST,pJeu);
	layout.putConstraint(SpringLayout.NORTH, labelTextNiveau,
                     20,
                     SpringLayout.SOUTH, lScore);
	
	// On cree le score et le positionne
	lNiveau=new JLabel("1");
	Font fniveau= new Font("Courier", Font.PLAIN, 30);
	lNiveau.setFont(fscore);
	monPanel.add(lNiveau);
	layout.putConstraint(SpringLayout.WEST, lNiveau,
                     20,
			     SpringLayout.EAST,pJeu);
	layout.putConstraint(SpringLayout.NORTH, lNiveau,
                     10,
                     SpringLayout.SOUTH, labelTextNiveau);


	// On construit le menu
	JMenuItem openItem = new JMenuItem("Nouvelle partie");
        JMenuItem quitItem = new JMenuItem("Quitter");
        
	JMenuBar menubar = new JMenuBar();  //Creation d'une barre de menu
	JMenu fileMenu = new JMenu("Fichier"); // Creation d'un menu
	menubar.add(fileMenu);
	fileMenu.add(openItem);     // Ajout d'un element au menu
	fileMenu.addSeparator();    // Ajout d'un element separateur
	fileMenu.add(quitItem);
		
	// On precise quelles sont les actions a realiser 
	// pour chaque element
	openItem.addActionListener(new OuvrirAction());
        quitItem.addActionListener(new QuitterAction());
	this.setJMenuBar(menubar);

	return monPanel;
    }


}